//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#include    <stdio.h>
#include    <shellapi.h>
#pragma hdrstop

#include "UnitGrph.h"
#include "UnitMain.h"
#include "UnitLib.h"
#include "UnitHint.h"
#include "SPI_LOAD.h"
#include "UnitBG.h"
//---------------------------------------------------------------------------
static double HeightPerWidth;
static int DifWidth, DifHeight;
static int OrgWidth, OrgHeight, IniWidth, IniHeight;
static int bResizable = false, bDisplayed = false, bActive = false;
static AnsiString asGrphType = "bmp|rle|wmf|emf|ico";
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormGrph *FormGrph;
TSpiload	Susie;
//---------------------------------------------------------------------------
__fastcall TFormGrph::TFormGrph(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::WMDropFiles(TWMDropFiles Msg)
{
	FormMain->WMDropFiles(Msg);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::ShowGrph(const AnsiString FileName)
{
    char buf[32];
	int color_depth = 0;
    bool sw = false;
	LPathName LPathName(FileName);

    if(FileName.Length() == 0) return;
    if(WindowState != wsNormal) WindowState = wsNormal;
    sprintf(buf, "EasyView [] ");
    FormGrph->Caption = (AnsiString)buf + FileName;
    bResizable = bDisplayed = false;
    ImageDisp->Stretch = false;
    ImageDisp->Align = alClient;
    DifWidth = Width - ClientWidth;
    DifHeight = Height - ClientHeight;
    ImageDisp->Align = alNone;
	if(isMatchType(FileName, "bmp|rle")) {
   		//	BitMap`̏
		ImageDisp->Picture->Bitmap->LoadFromFile(FileName);
		sw = true;
    } else if(isMatchType(FileName, "wmf|emf")) {
   		//	Windowşٌ`̏
   		ImageDisp->Picture->Metafile->LoadFromFile(FileName);
		sw = true;
    } else if(isMatchType(FileName, "ico")) {
   		//	ICON`̏
   		ImageDisp->Picture->Icon->LoadFromFile(FileName);
		sw = true;
	/*
   	} else if(isMatchType(FileName, "mag")) {
   		//	MAG`̏
    } else if(isMatchType(FileName, "gif")) {
   		//	GIF`̏
    } else if(isMatchType(FileName, "jpg|jpeg")) {
   		//	JPEG`̏
    */
   	} else {    //	Susie PlugIn
		if(Susie.set_file( FileName.c_str() )) {
			if(Susie.load()) {							// C[Wɕ\
				ImageDisp->Width = Susie.bmp->Width;	// TCY
				ImageDisp->Height = Susie.bmp->Height;
				ImageDisp->Picture->Bitmap = Susie.bmp;	// \
				color_depth = Susie.color_depth;
				sw = true;
			}
		}
    }
    if(sw) {
		ShowGrphSub();
        if(color_depth) {
	    	sprintf(buf, " [%dx%dx%d] ",
    	    			OrgWidth, OrgHeight, color_depth);
		} else {
	    	sprintf(buf, " [%dx%d] ",
    	    			OrgWidth, OrgHeight);
        }
    	FormGrph->Caption = LPathName.GetName() + (AnsiString)buf + FileName;
	} else {
        if(FormMain->Timer1->Enabled == false) {
	    	sprintf(buf, "EV Error: %s", LPathName.GetName().c_str());
			LShowInfo("ΉĂȂ摜tH[}bgł", buf);
		}
	    sprintf(buf, "EasyView [Error] ");
    	FormGrph->Caption = (AnsiString)buf + FileName;
		if(Visible == false) FormMain->SetFocusToMenu();
    }
    bActive = true;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::ShowGrphSub()
{
	int w, h;
    double r, rh;

    // popSize->Enabled = false;
    HeightPerWidth = (double)ImageDisp->Height / (double)ImageDisp->Width;
	OrgWidth = ImageDisp->Width;
    OrgHeight = ImageDisp->Height;
	if(FormMain->cbDrag->Checked) {
	    if(FormGrph->BorderStyle == bsNone) {
            FormBG->Visible = True;
			w = ImageDisp->Width;
	    	h = ImageDisp->Height;
	    	r = rh = 1.0;
	    	if( w > Screen->Width ) r = ((double)Screen->Width / (double)w);
	    	if( h > Screen->Height ) rh = ((double)Screen->Height / (double)h);
	    	if( r > rh ) r = rh;
	    	if( r < 1.0 ) {
	    	    ImageDisp->Stretch = true;
	            ImageDisp->Align = alClient;
				w = (int)(w * r);
	    	    h = (int)(h * r);
	        } else {
                if(popScreen->Checked) {
                    if(Screen->Width * HeightPerWidth > Screen->Height) {
                        h = Screen->Height;
                        w = h / HeightPerWidth;
                    } else {
                        w = Screen->Width;
                        h = w * HeightPerWidth;
                    }
    	    	    ImageDisp->Stretch = true;
	                ImageDisp->Align = alClient;
                }
            }
            ClientWidth = w;
            ClientHeight = h;
            ImageDisp->Align = alNone;
            Width = Screen->Width;
            Height = Screen->Height;
	    } else {
			w = ImageDisp->Width + DifWidth;
    		h = ImageDisp->Height + DifHeight;
	    	r = rh = 1.0;
   			if( w > Screen->Width ) r = ((double)Screen->Width / (double)w);
   			if( h > Screen->Height ) rh = ((double)Screen->Height / (double)h);
	    	if( r > rh ) r = rh;
			if( r < 1.0 ) {
				w = (int)(w * r);
	   		    h = (int)(h * r);
   			} else {
                if(popScreen->Checked) {
                    if(Screen->Width * HeightPerWidth > Screen->Height) {
                        h = Screen->Height;
                        w = h / HeightPerWidth;
                    } else {
                        w = Screen->Width;
                        h = w * HeightPerWidth;
                    }
                }
   			}
			Width = w;
       		Height = h;
        	if(112 < Width) {
		    	ImageDisp->Stretch = true;
   				ImageDisp->Align = alClient;
       		}
	       	bResizable = true;
    	}
    } else {
	    if(FormGrph->BorderStyle == bsNone) {
            Width = Screen->Width;
            Height = Screen->Height;
			w = ImageDisp->Width;
	    	h = ImageDisp->Height;
	    } else {
			w = ImageDisp->Width + DifWidth;
    		h = ImageDisp->Height + DifHeight;
            if(h > Screen->Height) w += 15;		// ۰ް̕
            if(w > Screen->Width) h += 15;		// ۰ް̕
   			Width = ( w > Screen->Width ) ? Screen->Width : w;
   			Height = ( h > Screen->Height ) ? Screen->Height : h;
        	if((112 < Width) && (w <= Screen->Width) && (h <= Screen->Height)) {
   				ImageDisp->Align = alClient;
   				ImageDisp->Align = alNone;
       		}
    	}
    }
    //	if(WindowState == wsMinimized) WindowState = wsNormal;
    IniWidth = Width;
    IniHeight = Height;
    bDisplayed = true;
    Origin(w, h);
    Show();
    if(FormBG->Visible) FormBG->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FullScreen(const bool boolChecked)
{
	FormGrph->BorderStyle = boolChecked ? bsNone : bsSizeable;
    // FormGrph->Color = boolChecked ? clBlack : clBtnFace;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormKeyPress(TObject *Sender, char &Key)
{
	switch(Key) {
    case VK_RETURN: popMainClick(Sender); Key = 0; break;
	case '*'      : popFullClick(Sender); break;
    case '/'      : /* if(popSize->Enabled) */ popSizeClick(Sender); break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormKeyDown(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
	if(!ImageDisp->Stretch) {
		if(Shift.Contains(ssCtrl)) {
			switch(Key) {
			case VK_NEXT : // No break
			case VK_DOWN :
            	VertScrollBar->Position += VertScrollBar->Increment;
            	break;
    		case VK_PRIOR:	// No break
			case VK_UP   :
            	VertScrollBar->Position -= VertScrollBar->Increment;
            	break;
			case VK_RIGHT:
            	HorzScrollBar->Position += HorzScrollBar->Increment;
            	break;
			case VK_LEFT :
            	HorzScrollBar->Position -= HorzScrollBar->Increment;
            	break;
            }
        } else if(Shift.Contains(ssShift)) {
			switch(Key) {
			case VK_NEXT :
            	VertScrollBar->Position += VertScrollBar->Range;
                break;
    		case VK_PRIOR:
            	VertScrollBar->Position -= VertScrollBar->Range;
                break;
			case VK_DOWN :
            	VertScrollBar->Position += (FormGrph->Height / 2);
            	break;
			case VK_UP   :
            	VertScrollBar->Position -= (FormGrph->Height / 2);
            	break;
			case VK_RIGHT:
            	HorzScrollBar->Position += (FormGrph->Width / 2);
            	break;
			case VK_LEFT :
            	HorzScrollBar->Position -= (FormGrph->Width / 2);
            	break;
            }
        } else {
			switch(Key) {
			case VK_NEXT :
            	VertScrollBar->Position += (FormGrph->Height / 2);
                break;
    		case VK_PRIOR:
            	VertScrollBar->Position -= (FormGrph->Height / 2);
                break;
            }
		}
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormShow(TObject *Sender)
{
	FormMain->mnuWinG->Enabled = true;
	//	hbOAhhbv̏
    DragAcceptFiles(Handle, true);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormHide(TObject *Sender)
{
	if(FormMain->Visible) {
		FormMain->mnuWinG->Enabled = false;
		FormMain->SetFocusToMenu();
		Application->Title = "EasyView";
	} else FormMain->Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormResize(TObject *Sender)
{
    static bool inResize = false;

	if(!bDisplayed) return;
    if(inResize) return;
    if( bResizable && (ImageDisp->Stretch || (FormGrph->Width > 112)) ){
        int cx, cy;
        inResize = true;
        cx = Width;
        cy = ( cx - DifWidth ) * HeightPerWidth + DifHeight;
        if( (Top + cy) <= Screen->Height ) Height = cy;
        else {
            cy = Screen->Height - Top;
            cx = ( cy - DifHeight ) / HeightPerWidth + DifWidth;
            Height = cy;
            Width = cx;
        }
    	ImageDisp->Stretch = true;      //  \摜Ƃ
   		ImageDisp->Align = alClient;
        inResize = false;
    }
	if(WindowState == wsMinimized) FormMain->Show();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popNextClick(TObject *Sender)
{
	HideBalloon();
	FormMain->mnuGrphClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popPrevClick(TObject *Sender)
{
	HideBalloon();
	FormMain->mnuLeftClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popMultiClick(TObject *Sender)
{
	HideBalloon();
	FormMain->mnuMultiClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popMainClick(TObject *Sender)
{
	HideBalloon();
	if(FormMain->Timer1->Enabled) FormMain->mnuMultiClick(Sender);
	FormMain->SetFocusToMenu();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popInsClick(TObject *Sender)
{
	HideBalloon();
	FormMain->mnuInsClick(Sender);
	if(!FormMain->cbNow->Checked) popMainClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popExitClick(TObject *Sender)
{
	HideBalloon();
	FormMain->mnuExitClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popFullClick(TObject *Sender)
{
	HideBalloon();
	FormMain->cbFull->Checked = !popFull->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popDragClick(TObject *Sender)
{
	HideBalloon();
	FormMain->cbDrag->Checked = !popDrag->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popSizeClick(TObject *Sender)
{
	HideBalloon();
	//  Left = 0;
    //  Top = 0;
    if(!FormMain->cbDrag->Checked) {
		ShowGrphSub();
        return;
	}
	if(OrgWidth < 112) {
    	ImageDisp->Align = alNone;
        ImageDisp->Stretch = false;
		Width = IniWidth;
    	Height = IniHeight;
    } else {
		Width = IniWidth;
    	Height = IniHeight;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popRepeatClick(TObject *Sender)
{
	HideBalloon();
	FormMain->cbRepeat->Checked = !popRepeat->Checked;
    FormMain->mnuRepeat->Checked = !popRepeat->Checked;
    popRepeat->Checked = !popRepeat->Checked;

}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::popCopyClick(TObject *Sender)
{
	HideBalloon();
	Clipboard()->Assign(ImageDisp->Picture);
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormActivate(TObject *Sender)
{
	FormMain->OutFocusFromMenu();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::PopupMenu1Popup(TObject *Sender)
{
	// PopupMenu1->Tag  1 ɐݒ肷
    // Tag == 1 ̃R|[lǧĂяô݈ȉ̏s
    // V[gJbgL[ȂǂɂĂяoł
    // Ăяo Tag Ă̂ŁAɂ蓮ύXł
	if( (((TComponent*)Sender)->Tag) == 1 ) {
	    if(FormMain->Timer1->Enabled) FormMain->mnuMultiClick(Sender);
		if(FormMain->mnuHint->Checked)
	   		ShowBalloon();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::ShowBalloon() {
	//	̊֐ɏoĂ鑦l͎bIȂ̂ł
    //	WIȶق̏ꍇ		+16 x -96
    //	߯߱ƭ̑傫	196 x 236
    const int curx = 16, cury = -96;
    const int cx = 196, cy = 236;
	POINT pos;

	if(FormMain->mnuHint->Checked) {
		HideBalloon();
		//
		GetCursorPos((LPPOINT)&pos);
		FormHint->Left = pos.x + curx;
	    FormHint->Top = pos.y + cury;
        if(FormHint->Left + cx > Screen->Width) {
        	FormHint->Left = Screen->Width - cx;
        }
		if(FormHint->Top < 0) {
        	FormHint->Top += FormHint->ClientHeight + cy;
            FormHint->Up = true;
        } else FormHint->Up = false;
        if(FormHint->Top + FormHint->ClientHeight + cy > Screen->Height) {
			FormHint->Top = Screen->Height - FormHint->ClientHeight - cy;
        }
		//
	    FormHint->LabelHint->Caption = Application->Hint;
		FormHint->Show();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::HideBalloon() {
	if(FormHint->Visible) FormHint->Hide();
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormMouseMove(TObject *Sender, TShiftState Shift,
	int X, int Y)
{
	HideBalloon();
}
//---------------------------------------------------------------------------
void __fastcall InitPlugin(AnsiString PathName) {
    Susie.set_spipath(PathName.c_str());		// SPI path set
}
//---------------------------------------------------------------------------
bool __fastcall isCanDisp(AnsiString FileName) {
	bool ret = false;

    if( isMatchType(FileName, asGrphType) ) ret = true;
    else if(Susie.set_file( FileName.c_str() )) ret = Susie.check();
    return ret;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::ImageDispClick(TObject *Sender)
{
    if(FormMain->Timer1->Enabled) FormMain->mnuMultiClick(Sender);
    else if(bActive) {
        if(isShift())   popPrevClick(Sender);
        else            popNextClick(Sender);
    } else bActive = true;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::FormDeactivate(TObject *Sender)
{
    bActive = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormGrph::Origin(int cx, int cy) {
    if(popFull->Checked) {
        if(FormGrph->BorderStyle == bsNone) {
            Left = 0;
            Top = 0;
            ImageDisp->Align = alNone;
            if(cx >= Screen->Width) ImageDisp->Left = 0;
            else ImageDisp->Left = (Screen->Width - cx) / 2;
            if(cy >= Screen->Height) ImageDisp->Top = 0;
            else ImageDisp->Top = (Screen->Height - cy) / 2;
        } else {
            if(cx >= Screen->Width) Left = 0;
            else Left = (Screen->Width - cx) / 2;
            if(cy >= Screen->Height) Top = 0;
            else Top = (Screen->Height - cy) / 2;
        }
    } else {
        Left = 0;
        Top = 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TFormGrph::popScreenClick(TObject *Sender)
{
    FormMain->mnuScreenClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFormGrph::ImageDispDblClick(TObject *Sender)
{
    if(!FormMain->Timer1->Enabled) FormMain->mnuMultiClick(Sender);
}
//---------------------------------------------------------------------------

void __fastcall TFormGrph::popTextClick(TObject *Sender)
{
    FormMain->mnuTextClick(Sender);    
}
//---------------------------------------------------------------------------


