//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\clipbrd.hpp>
#pragma hdrstop

#include "UnitText.h"
#include "UnitMain.h"
#include "UnitFile.h"
#include "UnitLib.h"
#include "UnitHint.h"
#include "HelpCont.h"
//---------------------------------------------------------------------------
const int sbChanged = 0;
const int sbInsert = 1;
const int sbHint = 2;
AnsiString asDateFormat = "yyyy'N'm''d'('dddd')' ampmh''m''s'b'";
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TFormText *FormText;
//---------------------------------------------------------------------------
__fastcall TFormText::TFormText(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormKeyPress(TObject *Sender, char &Key)
{
	switch(Key) {
    case VK_ESCAPE :
		if(ReplaceDialog1->Options.Contains(frReplaceAll)) {
			Key = 0;
        } else mnuMenuClick(Sender);
        break;
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormDblClick(TObject *Sender)
{
	mnuMenuClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuCloseClick(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuMenuClick(TObject *Sender)
{
	FormMain->SetFocusToMenu();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormShow(TObject *Sender)
{
	FormMain->mnuWinT->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormHide(TObject *Sender)
{
	FormMain->mnuWinT->Enabled = false;
	FormMain->SetFocusToMenu();
}
//---------------------------------------------------------------------------

void __fastcall TFormText::FormClose(TObject *Sender, TCloseAction &Action)
{
	FormText->Release();
    FormText = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormCloseQuery(TObject *Sender, bool &CanClose)
{
	CanClose = CloseQuery(Sender);
}
//---------------------------------------------------------------------------
bool __fastcall TFormText::CloseQuery(TObject *Sender)
{
	int RetValue;

	if(RichEditText->Modified) {
		RetValue = Application->MessageBox("ҏW͕̕ύXĂ܂B\r\nۑ܂H", "mF",
    						MB_ICONQUESTION | MB_YESNOCANCEL);
		if(RetValue == IDYES) RetValue = SaveAs(Sender);
    } else RetValue = IDNO;
    return (RetValue != IDCANCEL);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuExitClick(TObject *Sender)
{
	FormMain->mnuExitClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuUndoClick(TObject *Sender)
{
    SendMessage(RichEditText->Handle, WM_UNDO, 0, 0);
	mnuUndo->Enabled = false;
    popUndo->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuCutClick(TObject *Sender)
{
	RichEditText->CutToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuCopyClick(TObject *Sender)
{
	RichEditText->CopyToClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuPasteClick(TObject *Sender)
{
	RichEditText->PasteFromClipboard();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuDelClick(TObject *Sender)
{
	RichEditText->ClearSelection();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuAllClick(TObject *Sender)
{
	RichEditText->SelectAll();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuDateClick(TObject *Sender)
{
	TDateTime Date;
    AnsiString p;

    DateTimeToString(p,asDateFormat, Date.CurrentDateTime());
    RichEditText->SelText = p;
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuWrapClick(TObject *Sender)
{
	bool bTemp;

    bTemp = RichEditText->Modified;
	RichEditText->WordWrap = !mnuWrap->Checked;
    mnuWrap->Checked = !mnuWrap->Checked;
	RichEditText->Modified = bTemp;
	if(bTemp == false) {
		StatusBar1->Panels->Items[sbChanged]->Text = "";
		mnuUndo->Enabled = false;
        popUndo->Enabled = false;

    }
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuFindClick(TObject *Sender)
{
	if(RichEditText->SelLength > 0) FindDialog1->FindText = RichEditText->SelText;
	FindDialog1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuNextClick(TObject *Sender)
{
	if(FindDialog1->FindText.Length() > 0) FindDialog1Find(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuReplaceClick(TObject *Sender)
{
	if(RichEditText->SelLength > 0) ReplaceDialog1->FindText = RichEditText->SelText;
	StatusBar1->Panels->Items[sbHint]->Text = "ESCŁuׂĒuv𒆎~܂";
	ReplaceDialog1->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FindDialog1Find(TObject *Sender)
{
//	RichEditText->FindText(FindDialog1->FindText,
//    			 int StartPos, int Length,  stWholeWord | stMatchCase);
	int iPos;
	TSearchTypes Options;

    Options.Clear();
    if(FindDialog1->Options.Contains(frWholeWord)) Options << stWholeWord;
    if(FindDialog1->Options.Contains(frMatchCase)) Options << stMatchCase;
    iPos = RichEditText->FindText(
    		FindDialog1->FindText,
        	RichEditText->SelStart + 1,
            RichEditText->Lines->Text.Length() - RichEditText->SelStart,
            Options);
    if(iPos != -1) {
		RichEditText->SelStart = iPos;
    	RichEditText->SelLength = FindDialog1->FindText.Length();
	} else MessageBeep(MB_OK);
    RichEditText->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::ReplaceDialog1Find(TObject *Sender)
{
	int iPos;
	TSearchTypes Options;

    Options.Clear();
    if(ReplaceDialog1->Options.Contains(frWholeWord)) Options << stWholeWord;
    if(ReplaceDialog1->Options.Contains(frMatchCase)) Options << stMatchCase;
    iPos = RichEditText->FindText(
    		ReplaceDialog1->FindText,
        	RichEditText->SelStart + 1,
			RichEditText->Lines->Text.Length() - RichEditText->SelStart,
            Options);
    if(iPos != -1) {
		RichEditText->SelStart = iPos;
    	RichEditText->SelLength = ReplaceDialog1->FindText.Length();
	} else MessageBeep(MB_OK);
    RichEditText->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::ReplaceDialog1Replace(TObject *Sender)
{
	if(ReplaceDialog1->Options.Contains(frReplaceAll)) {
    	while(RichEditText->SelLength > 0) {
        	if(GetAsyncKeyState(VK_ESCAPE) & 0x8001) break;
           	RichEditText->SelText = ReplaceDialog1->ReplaceText;
       		ReplaceDialog1Find(Sender);
		}
    } else {
    	if(RichEditText->SelLength > 0) {
    		RichEditText->SelText = ReplaceDialog1->ReplaceText;
   	    	ReplaceDialog1Find(Sender);
		}
    }
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormCreate(TObject *Sender)
{
	StatusBar1->Panels->Items[sbInsert]->Text = "}";

}
//---------------------------------------------------------------------------
void __fastcall TFormText::RichEditTextChange(TObject *Sender)
{
	if(mnuUndo->Enabled == false) {
		if(RichEditText->Modified) {
			StatusBar1->Panels->Items[sbChanged]->Text = "ύX";
			mnuUndo->Enabled = true;
            popUndo->Enabled = true;
        }
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuOpenClick(TObject *Sender)
{
	FormMain->mnuTextClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormActivate(TObject *Sender)
{
	if(Visible && FormHint->Visible) FormHint->Hide();
	FormMain->OutFocusFromMenu();
}
//---------------------------------------------------------------------------
void __fastcall TFormText::ButtonFace(TObject *Sender)
{
	if(RichEditText->ReadOnly) {
    	mnuCopy->Enabled = (RichEditText->SelLength > 0);
        popCopy->Enabled = (RichEditText->SelLength > 0);
		mnuCut->Enabled = false;
        popCut->Enabled = false;
		mnuDel->Enabled = false;
        popDel->Enabled = false;
		mnuPaste->Enabled = false;
        popPaste->Enabled = false;
    } else {
		mnuCut->Enabled = (RichEditText->SelLength > 0);
        popCut->Enabled = (RichEditText->SelLength > 0);
		mnuCopy->Enabled = (RichEditText->SelLength > 0);
        popCopy->Enabled = (RichEditText->SelLength > 0);
        mnuDel->Enabled = (RichEditText->SelLength > 0);
        popDel->Enabled = (RichEditText->SelLength > 0);
	    mnuPaste->Enabled = Clipboard()->HasFormat(CF_TEXT);
        popPaste->Enabled = Clipboard()->HasFormat(CF_TEXT);
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuSaveClick(TObject *Sender)
{
	// LShowMessage(FileName);
    if(isFileWritable(FileName)) {
	    RichEditText->Lines->SaveToFile(FileName);
    	RichEditText->Modified = false;
		RichEditText->ReadOnly = false;
        mnuSave->Enabled = true;
   		StatusBar1->Panels->Items[sbChanged]->Text = "";
		mnuUndo->Enabled = false;
        popUndo->Enabled = false;
		FormFile->Filters("", asTextFilters);	// FormFile ̕\tbV
		FormFile->Filters(asTextFilter, asTextFilters);
    } else {
		LShowInfo("݋֎~̧قł\nʂ̖Oŕۑĉ",
			FileName);
	}
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuSaveAsClick(TObject *Sender)
{
	SaveAs(Sender);
}
//---------------------------------------------------------------------------
int __fastcall TFormText::SaveAs(TObject *Sender)
{
#ifdef BCBDIALOG
	int ret;

    if(RichEditText->ReadOnly)
	    LShowInfo("ǂݎp̧قƂĵ݂Ă܂\n"
    			"OtĕۑƕύX\ƂȂ܂",
                FileName);
    FormMain->SaveDialog->Title = "Otĕۑ";
    FormMain->SaveDialog->HelpContext = FILESAVE;
    FormMain->SaveDialog->FileName = FileName;
    FormMain->SaveDialog->Filter = asTextFilters;
    FormMain->SaveDialog->FilterIndex = 1;
    FormMain->SaveDialog->Options.Clear();
    FormMain->SaveDialog->Options << ofShowHelp
        << ofHideReadOnly << ofNoReadOnlyReturn << ofOverwritePrompt;
    FormMain->SaveDialog->Execute();
	if( (FormMain->SaveDialog->Files->Count > 0)
        && (FormMain->SaveDialog->FileName != "") )
    {
       	FileName = FormMain->SaveDialog->FileName;
		FormText->Caption = "EasyView - " + FileName;
       	mnuSaveClick(Sender);
        ret = IDYES;
    } else ret = IDCANCEL;
    return ret;
#else
	int ret;

    if(RichEditText->ReadOnly)
	    LShowInfo("ǂݎp̧قƂĵ݂Ă܂\n"
    			"OtĕۑƕύX\ƂȂ܂",
                FileName);
    FormFile->SetFileDialog(    //  Multi, Save, ReadOnly, FileList
        "Otĕۑ", FILESAVE, false, true, false, true,
        asTextFilter, asTextFilters,
        "ۑ(&S)", "t@Cۑ܂");
    FormFile->ChgFileName(FileName);
	if(FormFile->ShowModal() != mrCancel) {
    	if(isPathExist(FormFile->FileName)) {
        	if(isFileWritable(FormFile->FileName)) {
        		ret = LMessageBox("̧ق܂B㏑܂H",
            		 	FormFile->FileName,
                    	MB_YESNO | MB_ICONQUESTION | MB_DEFBUTTON2 );
            } else {
            	LShowInfo("̏݋֎~̧ق܂\nʂ̖Oŕۑĉ",
                	FormFile->FileName);
            	ret = IDCANCEL;
            }
        } else ret = IDYES;
        if(ret == IDYES) {
        	FileName = FormFile->FileName;
			FormText->Caption = "EasyView - " + FileName;
        	mnuSaveClick(Sender);
        } else ret = IDCANCEL;
    } else ret = IDCANCEL;
    return ret;
#endif
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuIndexClick(TObject *Sender)
{
	FormMain->mnuIndexClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::mnuKeywordClick(TObject *Sender)
{
	FormMain->mnuKeywordClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TFormText::FormResize(TObject *Sender)
{
	if(WindowState == wsMinimized) FormMain->Show();
}
//---------------------------------------------------------------------------
